/* -*- mode: C++; tab-width: 8; c-basic-offset: 8; c-file-offsets: ((substatement-open . 0)) -*- */

#include <xercesc/parsers/XercesDOMParser.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMException.hpp>
#include <xercesc/framework/MemBufInputSource.hpp>
#include <memory>
#include <iostream>

#include "../src/log.hpp"

using namespace std;
using namespace XERCES_CPP_NAMESPACE;

namespace {
const string xmldata = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?><xcf><arguments arg=\"v\"><flag>1</flag><flag>2</flag><foo>bar</foo><meier>teich</meier></arguments></xcf>";
}

int main(int argc, char* argv[])
{
	try {
		XMLPlatformUtils::Initialize();
		auto_ptr<XercesDOMParser> parser(new XercesDOMParser());
		parser->setDoNamespaces(true);

		MemBufInputSource input((unsigned char*)xmldata.c_str(),
		                        xmldata.length(),
		                        "", false);
		parser->parse(input);

		DOMDocument* doc1 = parser->adoptDocument();
		cerr << "doc1=" << doc1 << endl;
		if(NULL == doc1) {
			return -1;
		}
		parser->reset();

		DOMDocument* doc2 = parser->adoptDocument();
		cerr << "doc2=" << doc2 << endl;
		if(NULL != doc2) {
			return -1;
		}
	} catch(const DOMException& ex) {
		cerr << "DOMException[code=" << ex.code
		     << ", msg=" << ex.msg << "]";
		return -1;
	}
	return 0;
}
